2015-04-20  Tim Waugh  <twaugh@redhat.com>

	* configure.ac: Version 0.3.4.
	* NEWS: Updated.

2015-04-14  Tim Waugh  <twaugh@redhat.com>

	* src/filterdiff.c: Handle git extended headers.
	* Makefile.am: The fullheader1 test case should now pass.

	* tests/lsdiff6/run-test: Fixed typo.
	* tests/fullheader1/run-test: Fixed typo.

2015-04-13  Tim Waugh  <twaugh@redhat.com>

	* src/interdiff.c: Applied patch from Ulrich Drepper to fix
	fullheader2 test case.
	* Makefile.am: Now the test case is expected to pass.

	* tests/fullheader2/run-test: Another test for handling git
	output.
	* Makefile.am: Run it. Currently expected to fail.

2015-03-20  Tim Waugh  <twaugh@redhat.com>

	* tests/fullheader1/run-test: Test for handling git output.
	* Makefile.am: Run it. Currently expected to fail.

2015-02-19  Tim Waugh  <twaugh@redhat.com>

	* tests/recount7/run-test: Test for recountdiff with broken
	whitespace-only lines.
	* scripts/recountdiff.in: Be more forgiving of broken
	whitespace-only context lines (found due to bug #1194285).

2014-11-04  Tim Waugh  <twaugh@redhat.com>

	* NEWS: Updated.

	* splitdiff.in: New -D option, suggested by Ulf Samuelsson.
	* common.sh: Set path to splitdiff in the test environment.
	* tests/splitdiffD/run-test: Test splitdiff -D.
	* Makefile.am: Make sure splitdiff is up to date before
	running tests. Run splitdiffD test.
	* doc/patchutils.xml: Updated.

2014-10-17  Tim Waugh  <twaugh@redhat.com>

	* Makefile.am: Run delhunk6 test even though it is expected to
	fail.

	* tests/trimlast1/run-test: Test case for trac issue #32.
	* tests/trimlast1/run-test: Another one.
	* Makefile.am: Run them (they both currently fail).

2014-05-09  Tim Waugh  <twaugh@redhat.com>

	* src/filterdiff.c: Make --clean drop comments after '@@'
	lines as well (trac #29).
	* tests/clean2/run-test: Test case for that.
	* Makefile.am: Run it.

2013-04-11  Tim Waugh  <twaugh@redhat.com>

	* src/filterdiff.c: Don't show grepdiff-specific options in
	help output for filterdiff/lsdiff (bug #948973).

2013-04-02  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 0.3.3.

2011-05-26  Tim Waugh  <twaugh@redhat.com>

	* src/filterdiff.c (do_context): Handle "no newline" lines
	(trac #13, newline6 test case).

2011-05-25  Tim Waugh  <twaugh@redhat.com>

	* splitdiff.in: Output files now have a .patch filename
	extension, unless the new -E option is given.

2011-05-20  Tim Waugh  <twaugh@redhat.com>

	* src/rediff.c: Applied patch from Jiri Popelka to fix
	possible NULL pointer access.

	* src/diff.c: Applied patch from Jiri Popelka to fix incorrect
	use of sizeof for memory allocation.

	* src/diff.c, src/interdiff.c: Applied patch from Jiri Popelka
	to fix resource leaks.  Slight changes made my me.

2011-03-08  Tim Waugh  <twaugh@redhat.com>

	* tests/newline6/run-test: New test case for trac #13.
	* Makefile.am: Run it (currently fails).

2011-02-14  Tim Waugh  <twaugh@redhat.com>

	* src/util.c (patlist_add_file): Avoid PATH_MAX (trac #11).

	* tests/rediff2/run-test: Portability fix (trac #18).

2011-02-10  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 0.3.2.

2011-02-10  Tim Waugh  <twaugh@redhat.com>

	* editdiff.in: Do not run rediff if no changes were made (trac
	#14).

	* doc/patchutils.xml: Updated grepdiff documentation to
	include all its options (trac #17).

	* src/interdiff.c (apply_patch): Don't put absolute filenames
	in the input to patch.

2011-01-04  Tim Waugh  <twaugh@redhat.com>

	* src/util.c (xopen_unzip): Use correct exit status for
	"lsdiff -z nonexistentfile" (trac #16).

2009-08-10  Tim Waugh  <twaugh@redhat.com>

	* src/util.c (xtmpfile): Clean up temporary file (trac #12).
	Also free the memory allocated to hold its name.

2009-01-23  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 0.3.1.

2009-01-23  Tim Waugh  <twaugh@redhat.com>

	* src/filterdiff.c (main): Provide GNU-style long names for all
	options (trac #6).
	* src/interdiff.c (main): Likewise.
	* doc/patchutils.xml: Updated.

2009-01-23  Tim Waugh  <twaugh@redhat.com>

	* src/filterdiff.c (do_unified): Cope a little better with
	incomplete @@ lines.

2009-01-23  Tim Waugh  <twaugh@redhat.com>

	* src/rediff.c (adjust_offsets_and_copy): Keep the trailing text
	after @@ (trac #8).
	(removed_hunk): Likewise.

2009-01-21  Tim Waugh  <twaugh@redhat.com>

	* src/rediff.c (show_modified_hunk): If changes have been made
	outside the original diff, error out (trac #1).

2009-01-21  Tim Waugh  <twaugh@redhat.com>

	* tests/rediff2/run-test: New test case.

2009-01-21  Tim Waugh  <twaugh@redhat.com>

	* doc/patchutils.xml: Fixed typo (trac #7).

2009-01-21  Tim Waugh  <twaugh@redhat.com>

	* src/util.c (xtmpfile): New function.
	* src/interdiff.c (output_delta): Use it.
	(take_diff): Likewise.
	(interdiff): Likewise.
	* src/diff.c (do_convert): Likewise.
	* src/filterdiff.c (do_unified): Likewise.
	(do_context): Likewise.
	* src/rediff.c (added_hunk): Likewise.
	(show_modified_hunk): Likewise.
	(rediff): Likewise.
	* src/util.c (xopen_seekable): Likewise.
	(xopen_unzip): Likewise.

	The tmpfile() function is not specified to use the TMPDIR
	environment variable.  We wrap it to make sure that TMPDIR is
	honoured (trac #3).

2008-07-28  Tim Waugh  <twaugh@redhat.com>

	* src/interdiff.c (output_patch1_only): Clean up error messages.
	(output_delta): Likewise.
	Patch from Eli Carter.

2008-07-02  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 0.3.0 (stable).

2008-07-02  Tim Waugh  <twaugh@redhat.com>

	* src/filterdiff.c (clean_comments): New global.
	(filterdiff): Use it in determining whether to show non-diff
	lines.
	(syntax_str): Updated.
	(main): New option --clean.

	* doc/patchutils.xml: Updated.

	* tests/clean1/run-test: New test case.
	* Makefile.am (TESTS): Run it.

2008-07-02  Tim Waugh  <twaugh@redhat.com>

	* Makefile.am: Add TESTS and XFAIL_TESTS to EXTRA_DIST,
	instead of listing each test twice.

2008-06-11  Tim Waugh  <twaugh@redhat.com>

	* src/util.c (patlist_add_file): New function.
	* src/filterdiff.c (main): Use it, for new options -X and -I.
	(syntax_str): Updated.
	Original patch from Serj Kalichev.

	* doc/patchutils.xml: Updated.

	* tests/select2/run-test: Test -I (context format).
	* tests/select1/run-test: Test -I (unified format).
	* tests/select10/run-test: New test.  Test -x and -X for unified
	format.
	* tests/select11/run-test: New test.  Test -x and -X for context
	format.
	* Makefile.am (TESTS): Run new tests.

2008-06-11  Tim Waugh  <twaugh@redhat.com>

	* src/filterdiff.c (print_patchnames): Initial value is -1.
	(main): Initialise print_patchnames: if -H is allowed, and
	multiple input files are given, set it to 1; otherwise set it to
	0.

	* tests/lsdiff13/run-test: Verify that -H is the default when
	multiple files are given.

2005-08-10  Tim Waugh  <twaugh@redhat.com>

	* src/diff.c (best_name): Prevent use of uninitialised variable.

2005-07-22  Tim Waugh  <twaugh@redhat.com>

	* doc/patchutils.xml: Use referenceinfo for including author section.

2005-06-13  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 0.2.31.

2005-05-11  Tim Waugh  <twaugh@redhat.com>

	* tests/delhunk6/run-test: New failing rediff test.
	* Makefile.am: Run it.

	* src/interdiff.c (construct_unline): Fixed compiler warning.

	* splitdiff.in: Applied Debian patch to prevent warnings from
	splitdiff (Debian bug #306869).

2005-03-21  Tim Waugh  <twaugh@redhat.com>

	* doc/patchutils.xml: Fixed missing space (debian bug #299310).
	Patch from Michael Fedrowitz.

2005-02-26  Tim Waugh  <twaugh@redhat.com>

	* src/diff.c (read_atatline): Require decimal for offsets.  Reported
	by Robert Collins <robertc@robertcollins.net>.

2004-11-29  Tim Waugh  <twaugh@redhat.com>

	* src/filterdiff.c (syntax), src/rediff.c (main): Applied patch from
	Juan M. Bello Rivas <jmbr@openwall.com> to use xstrdup instead of
	strdup.

	* src/rediff.c (main): Applied patch from Juan M. Bello
	Rivas <jmbr@openwall.com>.

2004-11-22  Tim Waugh  <twaugh@redhat.com>

	* splitdiff.in: Applied patch from Martin Schulze <joey@infodrom.org>
	to use %03d when generating output filenames (Debian bug #282017).

2004-07-15  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 0.2.30 (stable).

2004-07-15  Tim Waugh  <twaugh@redhat.com>

	* src/filterdiff.c (display_filename): Better padding for file
	number.

2004-07-07  Tim Waugh  <twaugh@redhat.com>

	* src/diff.c (read_timezone): New function.
	(read_timestamp): Use it.  Suggested by Shawn Wagner, for parsing
	another common traditional date format.

2004-07-03  Tim Waugh  <twaugh@redhat.com>

	* src/filterdiff.c (syntax): Explain --number-files a bit more.

	* src/filterdiff.c (hunk_matches): Don't call file_matches()
	unnecessarily.

2004-07-02  Tim Waugh  <twaugh@redhat.com>

	* src/filterdiff.c: New --number-files option for lsdiff/grepdiff.
	* doc/patchutils.xml (lsdiff): Document it.

2004-05-19  Tim Waugh  <twaugh@redhat.com>

	* src/filterdiff.c (hunk_matches): Small correction.

2004-05-14  Tim Waugh  <twaugh@redhat.com>

	* doc/patchutils.xml (interdiff.1): Clarify requirement for
	reference files being exactly the same.

2004-05-07  Tim Waugh  <twaugh@redhat.com>

	* doc/patchutils.xml: For grepdiff -n output format refer to the
	lsdiff man page.

	* src/filterdiff.c (main): Prevent -n being accepted by
	filterdiff.

2004-05-06  Tim Waugh  <twaugh@redhat.com>

	* doc/patchutils.xml: Include --hunks/--lines/--files in lsdiff man
	page.

	* src/filterdiff.c: Fixed --help output.

	* src/filterdiff.c: Added --files option, based on work by
	Sérgio Monteiro Basto <sergiomb@netcabo.pt>.
	* doc/patchutils.xml: Document it.

	* tests/lsdiff12/run-test: Avoid using /dev/stdin, which is not
	available on Cygwin set-ups.
	* tests/flip*/run-test: Use /bin/echo instead of the shell builtin.
	Patch from Max Bowsher <maxb@ukf.net>.

2004-04-16  Tim Waugh  <twaugh@redhat.com>

	* src/filterdiff.c (do_unified): Handle no-newline line counts
	correctly.

	* tests/newline5/run-test: New test.
	* Makefile.am: Run it.

2004-04-05  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 0.2.29 (stable).

2004-04-02  Tim Waugh  <twaugh@redhat.com>

	* src/filterdiff.c (do_unified): Fix grep delayed-output logic.

	* tests/grepdiff7/run-test: New test.
	* Makefile.am: Run it.

2004-03-27  Tim Waugh  <twaugh@redhat.com>

	* tests/*/run-test: Use -s to test for errors.

	* src/interdiff.c (creare_orig): Fix no-newline handling (Debian
	bug #240406).

	* tests/newline4/run-test: New test case, from Debian bug #240406.
	* Makefile.am: Run it.

2004-03-25  Tim Waugh  <twaugh@redhat.com>

	* src/filterdiff.c (do_context): Generate context format that GNU
	patch actually understands.
	* tests/convert2/run-test: Check that multiple hunk context output
	is accepted by GNU patch.
	* tests/grepdiff4/run-test: Expect GNU patch compatible context
	format.

2004-03-10  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 0.2.28 (stable).

2004-03-10  Tim Waugh  <twaugh@redhat.com>

	* tests/convert1/run-test, tests/convert2/run-test: New tests.
	* Makefile.am: Run them.

	* src/diff.c (copy_context_hunks): Share variable holding getline
	return value with caller to avoid getting in a muddle.
	(convert_context_hunks_to_unified): Initialize linelengths array.

2004-03-09  Tim Waugh  <twaugh@redhat.com>

	* src/filterdiff.c (filterdiff): Pass through partial diff headers
	in verbose mode or when excluding.

2004-02-26  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 0.2.27 (stable).

2004-02-26  Tim Waugh  <twaugh@redhat.com>

	* dehtmldiff.in: Display the line containing the unknown entity to
	stderr, where the error message went.  Translate &quot;.

2004-01-22  Tim Waugh  <twaugh@redhat.com>

	* doc/patchutils.xml: Note strict requirements of interdiff and
	combinediff.

2004-01-16  Tim Waugh  <twaugh@redhat.com>

	* tests/nul0/run-test, tests/nul1/run-test, tests/nul2/run-test,
	tests/nul3/run-test: New tests.
	* Makefile.am: Run them.

	* src/diff.c: Handle embedded null characteres.

2004-01-15  Tim Waugh  <twaugh@redhat.com>

	* src/filterdiff.c (do_unified): Handle embedded null characters. 
	(do_context): Likewise.

	* src/interdiff.c: Likewise.

	* src/interdiff.c (output_delta): Fixed typo spotted by Michael
	Fedrowitz.

2004-01-15  Tim Waugh  <twaugh@redhat.com>

	* tests/lsdiff14/run-test, tests/lsdiff15/run-test: New tests.
	* Makefile.am: Run them.

	* doc/patchutils.xml: Document lsdiff -E.

2004-01-14  Tim Waugh  <twaugh@redhat.com>

	* src/interdiff.c (construct_unline): Fix compiler warning.

	* src/filterdiff.c (do_unified): Implement -E option for lsdiff.

	* src/filterdiff.c (do_context): Likewise.

2004-01-12  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 0.2.26 (stable).

2004-01-12  Tim Waugh  <twaugh@redhat.com>

	* doc/patchutils.xml: Suggested improvement in wording.

2004-01-07  Tim Waugh  <twaugh@redhat.com>

	* src/interdiff.c (output_patch1_only): Use size_t* for 2nd
	argument to getline.
	(trim_context): Likewise.
	(output_delta): Likewise.
	Patch from Yoshihiro Toda <yoshihiro_toda@mac.com>.

	* src/filterdiff.c (do_unified): Make linelen a size_t*, since
	that's how it is used.
	(do_context): Likewise.
	(read_regex_file): Likewise.
	Patch from Yoshihiro Toda <yoshihiro_toda@mac.com>.

2003-12-21  Tim Waugh  <twaugh@redhat.com>

	* src/interdiff.c, src/rediff.c: Move always-executed code outside
	assert() so that NDEBUG builds work.

2003-12-14  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 0.2.25 (stable).

2003-10-30  Tim Waugh  <twaugh@redhat.com>

	* splitdiff.in (process): Avoid ugliness caused by 'diff -u ...'
	lines not being start-of-diff markers.  Patch from Eric
	Wong <normalperson@yhbt.net>.

2003-10-21  Tim Waugh  <twaugh@redhat.com>

	* splitdiff.in: Added '-d' option so that 'splitdiff -ad' operates
	a bit more like diffsplit, for Debian bug #215870.
	* doc/patchutils.xml: Updated documentation.

2003-09-30  Tim Waugh  <twaugh@redhat.com>

	* dehtmldiff.in: Make shell-generic, from Dmitry V. Levin
	<ldv@altlinux.org>.

2003-08-28  Tim Waugh  <twaugh@redhat.com>

	* src/util.c (getline): Apply fix from Max Bowsher <maxb@ukf.net>.

2003-07-31  Tim Waugh  <twaugh@redhat.com>

	* src/filterdiff.c (syntax): Dynamic --help output.

	* src/filterdiff.c: Support --with-filename as a synonym for -H.
	Add support for -h/--no-filename to allow us to assume -H in the
	future when there are multiple input files.
	* doc/patchutils.xml: Document it.
	* tests/lsdiff3/run-test, tests/lsdiff11/run-test: Specify -h/-H.

2003-07-28  Tim Waugh  <twaugh@redhat.com>

	* tests/lsdiff13/run-test: New test for -H.
	* Makefile.am: Run it.

2003-07-26  Tim Waugh  <twaugh@redhat.com>

	* src/filterdiff.c (do_context): Fix left-behind NULL.

2003-07-26  Tim Waugh  <twaugh@redhat.com>

	* src/filterdiff.c: Implement -H option similarly to GNU grep; it
	displays the filenames containing the matches.  Based on patch by
	David Necas <yeti@physics.muni.cz>.

2003-07-25  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 0.2.24 (stable).

2003-07-25  Tim Waugh  <twaugh@redhat.com>

	* src/filterdiff.c (file_exists): Treat /dev/null as nonexistent.
	* tests/lsdiff12/run-test: New test.
	* Makefile.am: Run test.

2003-07-07  Tim Waugh  <twaugh@redhat.com>

	* doc/patchutils.xml: Fix typo (debian bug #198068).

2003-06-13  Tim Waugh  <twaugh@redhat.com>

	* src/filterdiff.c: Move timestamp code to..
	* src/diff.c (read_timestamp): ..here.
	(filename_from_header): Function for intuiting the filename.
	* src/diff.h: Prototypes for new functions.
	* src/filterdiff.c (filterdiff): Use filename_from_header.
	* src/interdiff.c (index_patch2, interdiff): Likewise.
	* tests/lsdiff11/run-test: New tests for filename intuition.
	* Makefile.am: Run it.

2003-06-12  Tim Waugh  <twaugh@redhat.com>

	* src/filterdiff.c: Add grepdiff's -f option to --help output.

2003-06-10  Tim Waugh  <twaugh@redhat.com>

	* src/diff.c, src/interdiff.c: Fix signed/unsigned comparisons.

	* src/filterdiff.c (read_regex_file): New function to implement
	'grepdiff -f FILE'.
	* doc/patchutils.xml: Document it.

2003-06-07  Tim Waugh  <twaugh@redhat.com>

	* src/filterdiff.c (egrepping): New global.
	(main): Handle -E option.
	(syntax_str): Display -E option in help.
	* doc/patchutils.xml: Document it.

2003-06-05  Tim Waugh  <twaugh@redhat.com>

	* src/filterdiff.c (output_header_line): Implement timestamp
	removal.
	* doc/patchutils.xml (filterdiff.1): Document it.

2003-06-05  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 0.2.23 (stable).

2003-06-05  Tim Waugh  <twaugh@redhat.com>

	* src/interdiff.c (apply_patch): Take note of exit status of
	sub-process.
	(flipdiff): Abort on error.
	(output_delta): Likewise.  Fixes Red Hat bugzilla bug #92320.

2003-04-11  Tim Waugh  <twaugh@redhat.com>

	* src/interdiff.c (index_patch2, interdiff): Warn if non-empty
	input file contains no patch (debian bug #187767).  Based on patch
	by Michael Fedrowitz <michaelf@debian.org>.

2003-03-19  Tim Waugh  <twaugh@redhat.com>

	* editdiff.in: Fix behaviour when no parameters are given.
	Be verbose if rediff fails (debian bug #185345).

2003-03-11  Tim Waugh  <twaugh@redhat.com>

	* tests/flip1/run-test, tests/flip1/run-test, tests/flip1/run-test,
	tests/flip1/run-test, tests/flip1/run-test, tests/flip1/run-test,
	tests/flip1/run-test, tests/flip1/run-test, tests/flip1/run-test,
	tests/flip1/run-test, tests/flip1/run-test, tests/flip1/run-test,
	tests/flip1/run-test, tests/flip1/run-test, tests/flip1/run-test,
	tests/flip1/run-test, tests/flip1/run-test, tests/flip1/run-test,
	tests/flip1/run-test: Make sed usage compatible with older versions.

2003-03-08  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 0.2.22 (stable).

2003-03-08  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Check for a default editor.
	* editdiff.in: Use it.

2003-03-06  Tim Waugh  <twaugh@redhat.com>

	* doc/patchutils.xml: Don't use <sbr/> any more, now that xmlto
	wraps <cmdsynopsis> properly.

2003-03-05  Tim Waugh  <twaugh@redhat.com>

	* src/filterdiff.c (do_unified): Prevent uninitialised use of
	first_hunk.

	* espdiff.in, configure.in: Implementation.
	* Makefile.am: Ship it.

	* doc/patchutils.xml (espdiff.1): New man page.

2003-03-03  Tim Waugh  <twaugh@redhat.com>

	* fixcvsdiff.in: More tweaking.

2003-03-03  Tim Waugh  <twaugh@redhat.com>

	* fixcvsdiff.in: Add patch from Eli Carter <eli.carter@inet.com>
	to make output easier for vim parsing.

2003-03-03  Tim Waugh  <twaugh@redhat.com>

	* tests/number1/run-test, tests/number2/run-test: New tests for
	filterdiff --as-numbered-lines.
	* src/filterdiff.c (do_unified, do_context): Pass them.
	(do_context): Simply code a little.

	* Makefile.am: Run them.

	* src/filterdiff.c (main): Prevent grepdiff --as-numbered-lines unless
	--output-matching is also given.

	* src/filterdiff.c (do_context): Make --as-numbered-lines and
	--output-matching get along.
	* Makefile.am: Now we pass grepdiff6.

2003-03-02  Tim Waugh  <twaugh@redhat.com>

	* tests/grepdiff6/run-test: New test; context format equivalent of
	grepdiff5.
	* Makefile.am: Run it, but don't expect to pass yet.

	* tests/grepdiff5/run-test: New test.
	* Makefile.am: Run test.

	* src/filterdiff.c (do_context): Tend to severe indentationitis.
	(do_unified): Make --as-numbered-lines and --output-matching get
	along.

2003-03-01  Tim Waugh  <twaugh@redhat.com>

	* src/filterdiff.c (main): Weed out invalid option combinations.
	(do_unified, do_context): Weed out superfluous tests.

	* src/filterdiff.c (do_context): Fix annotations (missing newline).
	Fix up offset munging for --output-matching=hunk.
	* tests/grepdiff4/run-test: Test offset munging.
	* Makefile.am: Run test.

	* src/filterdiff.c (do_unified): Fix up offset munging for
	--output-matching=hunk.
	* tests/grepdiff3/run-test: Test offset munging for
	--output-matching=hunk.
	* Makefile.am: Run test.

2003-03-01  Tim Waugh  <twaugh@redhat.com>

	* doc/patchutils.xml (grepdiff_: Document --output-matching.

	* src/filterdiff.c (do_unified): Support --output-matching.
	(do_context): Likewise (but it doesn't work right yet).

	* tests/grepdiff2/run-tests: New test (grepdiff and -nv).
	* Makefile.am: Run it.

	* tests/lsdiff10/run-test: New test (non-diff lines with -v).
	* Makefile.am: Run it.

2003-02-28  Tim Waugh  <twaugh@redhat.com>

	* src/filterdiff.c (do_unified, do_context): Give meaning to -v
	with grepdiff, and fix lsdiff -v behaviour.
	* doc/patchutils.xml (grepdiff): Document -v.

	* src/filterdiff.c (filterdiff): Don't show non-diff lines unless
	filtering.

	* doc/patchutils.xml: Formatting change for grepdiff.

2003-02-28  Tim Waugh  <twaugh@redhat.com>

	* splitdiff.in: Eliminate sed dependency to increase efficiency.

2003-02-28  Tim Waugh  <twaugh@redhat.com>

	* splitdiff.in: Add 'a' option to split out every single
	file-level patch.
	* doc/patchutils.xml: Document it.

2003-02-21  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 0.2.21 (stable).

2003-02-21  Tim Waugh  <twaugh@redhat.com>

	* src/interdiff.c (interdiff): Surround flipdiff marker with newlines,
	to prevent confusing unwrapdiff.
	* tests/flip*/run-test: Adjust accordingly.

	* doc/patchutils.xml (flipdiff): Document more options.

	* tests/unline1/run-test: New test where evasive action is not needed
	now.
	* Makefile.am: Run it.

	* src/interdiff.c (output_delta): Now that trim_context is a little
	smarter, we don't have to take evasive action quite so often.

2003-02-20  Tim Waugh  <twaugh@redhat.com>

	* doc/patchutils.xml (flipdiff.1): Warn that the output may not
	always be what you expect.

	* src/interdiff.c (trim_context): Abort if hunk-splitting would be
	required.

	* tests/flip18/run-test, tests/flip19/run-test: New tests.
	* Makefile.am: Run them.

	* src/interdiff.c (trim_context): Same corner-case for pre trimming.

	* tests/flip4/run-test: Correction.

	* src/interdiff.c (trim_context): Deal with corner-case for post
	trimming (now we pass flip17).

	* tests/flip17/run-test: New test.
	* Makefile.am: Run it.  We don't pass it yet.

	* dehtmldiff.in: Check for entities we didn't translate.

	* tests/flip16/run-test: New test.
	* Makefile.am: Run it.

2003-02-19  Tim Waugh  <twaugh@redhat.com>

	* src/interdiff.c (offset_at_line, patch2_removes_line, flipdiff):
	Completely re-wrote offset handling.

2003-02-17  Tim Waugh  <twaugh@redhat.com>

	* src/interdiff.c (remove_line): We pass flip15 now, but somehow
	it doesn't feel right.

	* tests/flip15/run-test: New test.
	* Makefile.am: Run it.  We don't pass it yet.

2003-02-17  Tim Waugh  <twaugh@redhat.com>

	* src/interdiff.c (offset_at_line): Think it's better now.
	(patch2_removes_line): Needed similar fixing.

	* tests/flip13/run-test, tests/flip14/run-test: New tests.
	* Makefile.am: Run them.

	* src/interdiff.c (offset_at_line): More fixes, but still doesn't
	seem quite right yet.

2003-02-17  Tim Waugh  <twaugh@redhat.com>

	* tests/flip12/run-test: New test.
	* Makefile.am: Run it.

	* src/interdiff.c (offset_at_line): Correct for insertions.

	* dehtmldiff.in: Fix argument parsing.

2003-02-16  Tim Waugh  <twaugh@redhat.com>

	* tests/flip11/run-test: New test.
	* Makefile.am: Run it.

	* src/interdiff.c (flipdiff): More parsing code improvements.

	* tests/flip10/run-test: New test.
	* Makefile.am: Run it.

	* tests/common.sh: Use -s option to patch.

	* src/interdiff.c (trim_context): Handle trimming from either end,
	not just the start.

	* src/interdiff.c (flipdiff): Redo parsing code in the manner of
	interdiff().

2003-02-12  Tim Waugh  <twaugh@redhat.com>

	* tests/common.sh: If VERBOSE environment variable is non-empty,
	set -x.
	* tests/*/run-test: Don't set -x here.

	* src/rediff.c (main): Use execvp not execv for recountdiff (patch
	from Michael Fedrowitz).

2003-02-04  Tim Waugh  <twaugh@redhat.com>

	* src/interdiff.c (add_to_list): Don't reverse the order of the
	files.

2003-02-04  Tim Waugh  <twaugh@redhat.com>

	* src/interdiff.c (interdiff): Really write flipped diffs to the
	right files when --in-place.

2003-02-03  Tim Waugh  <twaugh@redhat.com>

	* doc/patchutils.xml (filterdiff.1): Fix wrapping.

2003-02-02  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 0.2.20 (stable).

2003-02-02  Tim Waugh  <twaugh@redhat.com>

	* move-to-front: Helper script for using flipdiff.
	* Makefile.am: Ship it in the tarball.

	* interdiff.c (add_line, create_orig): Count line clashes.
	(flipdiff): Refuse to proceed if there are any clashes.

2003-02-02  Tim Waugh  <twaugh@redhat.com>

	* doc/patchutils.xml (flipdiff.1): Warn that the patches should be
	"clean".

	* tests/flip9/run-test: New test.
	* Makefile.am: Run it.

	* src/interdiff.c (interdiff): When writing flipped patches in place,
	write to the right files.

	* src/interdiff.c: Don't ever revert patches when flipping.

2003-02-01  Tim Waugh  <twaugh@redhat.com>

	* tests/flip8/run-test: New test.
	* src/interdiff.c (flipdiff): Remove bad 'break;' from loop.
	* Makefile.am: Now we pass flip8.

	* tests/flip7/run-test: New test.
	* Makefile.am: Run it.

	* src/interdiff.c (main): Don't allow --in-place unless we are
	behaving as flipdiff.

2003-01-31  Tim Waugh  <twaugh@redhat.com>

	* tests/flip5/run-test, tests/flip6/run-test: New tests.
	* Makefile.am: Run them.

	* src/interdiff.c (flipdiff): Fix bug.  Now we pass flip5.

2003-01-31  Tim Waugh  <twaugh@redhat.com>

	* tests/flip4/run-test: New test.
	* Makefile.am: Run it.
	* src/interdiff.c: Sort out first_offset problem to fix flip4.

2003-01-31  Tim Waugh  <twaugh@redhat.com>

	* tests/flip2/run-test, tests/flip2/run-test: New tests.
	* Makefile.am: Run them.

	* doc/patchutils.xml: Document flipdiff.
	* Makefile.am: Ship flipdiff.1.

	* src/interdiff.c: New option --in-place for flipdiff.

	* tests/flip1/run-test: New test.
	* Makefile.am: Run it.

	* tests/common.sh: Support flipdiff testing.

	* Makefile.am: Ship flipdiff.
	* src/interdiff.c: New command flipdiff.  Still a bit rudimentary.

	* src/interdiff.c (do_output_patch1_only, output_patch1_only,
	trim_context, output_delta, copy_residue): New parameter (where to
	send output).

	* src/util.h, src/util.c: New function xrealloc.

2003-01-30  Tim Waugh  <twaugh@redhat.com>

	* src/interdiff.c (main): Propagate errors.
	Also some preliminary work on flipdiff.
	Formatting changes.

2003-01-23  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 0.2.19 (stable).

2003-01-23  Tim Waugh  <twaugh@redhat.com>

	* src/interdiff.c (create_orig): Note the minimum leading context.
	(output_patch1_only): Trim -U to the minimum leading context.
	* Makefile.am: Now we pass U3.

	* src/interdiff.c (create_orig): Note the first offset.
	(write_file): Write unlines up to the first offset.
	(merge_lines): Merge first offsets.

	* tests/U3/run-test: New test.
	* Makefile.am: Run it.  We don't pass it yet.

2003-01-22  Tim Waugh  <twaugh@redhat.com>

	* editdiff.in: Don't run interdiff -U3, since it behaves badly
	when there are fewer than the specified number of context lines.

	* Makefile.am: Make sure the tests are executable.

	* tests/rediff1/run-test: New test.
	* Makefile.am: Run it.
	* src/rediff.c (show_modified_hunk): Pass it.

2003-01-17  Tim Waugh  <twaugh@redhat.com>

	* dehtmldiff.in: New file.
	* configure.in: Create dehtmldiff from it.
	* Makefile.am: Ship it.
	* doc/patchutils.xml: Document it.

2002-12-16  Tim Waugh  <twaugh@redhat.com>

	* src/filterdiff.c (file_exists): Fix thinko.

2002-12-16  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 0.2.18 (stable).

2002-12-16  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Fix LIBOBJ handling.

2002-12-13  Ville Skyttä <ville.skytta@iki.fi>

	* fixcvsdiff.in: Fix header paths up from the Index: line.

2002-10-15  Tim Waugh  <twaugh@redhat.com>

	* src/filterdiff.c (file_exists): Handle ISO 8601 timezones.
	* tests/lsdiff3/run-test: Test ISO 8601 timezones.

2002-10-11  Tim Waugh  <twaugh@redhat.com>

	* doc/patchutils.xml (splitdiff.1): Clarifications.

2002-09-10  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 0.2.17 (stable).

2002-09-03  Tim Waugh  <twaugh@redhat.com>

	* src/filterdiff.c (main): Close each input file given on the
	command line after use.

	* src/interdiff.c (main): Use mode "m" to permit the C library to
	use mmap(2).
	* src/filterdiff.c (main): Likewise.
	* src/rediff.c (rediff): Likewise.

2002-08-23  Tim Waugh  <twaugh@redhat.com>

	* doc/patchutils.xml (filterdiff.1): Add example for forma
	conversion.

2002-08-22  Tim Waugh  <twaugh@redhat.com>

	* src/diff.c: Line number tracking, for reporting errors.

2002-08-21  Tim Waugh  <twaugh@redhat.com>

	* editdiff.in: Normalize the amount of context after the edit.  Also,
	ensure that the input is in unified format.

	* src/interdiff.c: Fix -U3.

2002-08-21  Tim Waugh  <twaugh@redhat.com>

	* src/filterdiff.c (do_context): Better logic for detecting when
	to lines can be omitted.
	* tests/context1/run-test: New test.
	* Makefile.am: Run it.

2002-08-21  Tim Waugh  <twaugh@redhat.com>

	* src/interdiff.c (main): Handle context diffs by using
	convert_to_unified.
	* doc/patchutils.xml (interdiff.1, combinediff.1): Adjust diff
	format notes.

	* src/filterdiff.c (do_context): Copy annotations.

	* src/filterdiff.c (filterdiff): Use -v when filtering.
	* doc/patchutils.xml: Document that.

	* src/filterdiff.c (convert_format): New function.
	(main): Use it.

2002-08-20  Tim Waugh  <twaugh@redhat.com>

	* src/filterdiff.c: New option --format=unified|context.
	* doc/patchutils.xml: Document it.

	* src/filterdiff.c (do_context): Emit line count when to lines are
	omitted.

	* src/diff.c (do_convert_to_context): Implement conversion
	from unified diff to context diff.
	(do_convert_to_unified): Implement conversion from context diff
	to unified diff.

2002-08-20  Tim Waugh  <twaugh@redhat.com>

	* src/diff.h: New function prototypes for diff format conversion.
	* src/diff.c (convert_to_context, convert_to_unified,
	do_convert): New functions.  Framework for diff format conversion.
	(do_convert_to_context, do_convert_to_unified): Stub functions.
	No conversion done yet.

2002-08-16  Tim Waugh  <twaugh@redhat.com>

	* src/rediff.c (syntax): Fix missing argument (spotted by
	Jonathan Paisley <jp@dcs.gla.ac.uk>).

2002-08-16  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 0.2.16 (stable).

2002-08-15  Tim Waugh  <twaugh@redhat.com>

	* src/diff.c (stripped): Fix basename extraction.
	* tests/overstrip/run-test: New test.
	* Makefile.am: Now we pass it.

2002-07-24  Tim Waugh  <twaugh@redhat.com>

	* recountdiff.in: Fix a bug in handling entirely-added files.
	* tests/recount6/run-test: New test case.
	* Makefile.am: Now we pass it.

2002-07-22  Tim Waugh  <twaugh@redhat.com>

	* doc/patchutils.xml (interdiff.1): Warn about interdiff having
	stricter requirements on the input format than patch(1).

2002-07-22  Tim Waugh  <twaugh@redhat.com>

	* src/interdiff.c (copy_residue): Use output_patch1_only for
	output.
	(do_output_patch1_only): Switch headers around when reverting.

2002-07-22  Tim Waugh  <twaugh@redhat.com>

	* src/interdiff.c (output_patch1_only): Renamed to..
	(do_output_patch1_only): This.
	(output_patch1_only): New function.  Use diff_opts and max_context
	if set.  Hmm, quite similar to output_delta, but not quite similar
	enough.
	* doc/patchutils.xml (interdiff.1): Updated BUGS.

2002-07-19  Tim Waugh  <twaugh@redhat.com>

	* src/filterdiff.c: New option --annotate.
	* doc/patchutils.xml: Document it.

	* src/filterdiff.c (do_context): Handle diff -pc output.

2002-07-11  Tim Waugh  <twaugh@redhat.com>

	* src/rediff.c (main): If only one argument is given, behave like
	recountdiff (by just running it, for now).
	(syntax_str): Document this behaviour.
	* doc/patchutils.xml: Likewise.

	* src/rediff.c (rediff): Refuse to handle input that looks like
	context format, since we don't handle that yet (bug #68555).

2002-07-10  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 0.2.15 (stable).

2002-07-10  Tim Waugh  <twaugh@redhat.com>

	* recountdiff.in, doc/patchutils.xml: Updated to reflect new name.
	* tests/common.sh, tests/recount1/run-test, tests/recount2/run-test,
	tests/recount3/run-test, tests/recount4/run-test,
	tests/recount5/run-test: Likewise.

	* recount.in: Moved...
	* recountdiff.in: ... here.
	* Makefile.am, configure.in: Adjust as appropriate.

2002-07-09  Tim Waugh  <twaugh@redhat.com>

	* tests/common.sh: Allow for unwrapdiff tests.
	* tests/unwrapdiff1/run-test: New test.
	* Makefile.am: Run it.

	* recount.in: Remove unneeded declaration.

	* src/filterdiff.c (syntax_str): Describe --as-numbered-lines.

	* tests/recount5/run-test: New test.
	* Makefile.am: Run it.

	* unwrapdiff.in: New file.
	* configure.in: Create unwrapdiff from unwrapdiff.in.
	* doc/patchutils.xml: Document unwrapdiff.
	* Makefile.am: Ship unwrapdiff and its man page.

2002-07-07  Michael Fedrowitz  <michaelf@debian.org>

	* doc/patchutils.xml: Add a cmdsynopsis for editdiff.

2002-07-06  Tim Waugh  <twaugh@redhat.com>

	* tests/recount4/run-test: New test.
	* recount.in: Handle empty hunks.
	* Makefile.am: Now we pass recount4.

	* tests/recount3/run-test: New test.
	* Makefile.am: Run it.

	* doc/patchutils.xml: Point out the main limitation of recount.

	* tests/recount2/run-test: New test.
	* recount.in: Reset running offset between files.
	* Makefile.am: Now we pass recount2.

	* tests/common.sh: Allow for recount tests.
	* tests/recount1/run-test: First recount test.
	* Makefile.am: Run test.

	* src/filterdiff.c (file_exists): Adjust code to match comment.

2002-07-05  Tim Waugh  <twaugh@redhat.com>

	* doc/patchutils.xml: Add IDs to the refentry elements.

2002-07-05  Tim Waugh  <twaugh@redhat.com>

	* recount.in: New file, suggested by Arjan Van de Ven.
	* configure.in: Create recount from recount.in.
	* doc/patchutils.xml: Document recount.
	* Makefile.am: Ship recount and its man page.

2002-05-18  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 0.2.14 (stable).

2002-05-18  Tim Waugh  <twaugh@redhat.com>

	* src/filterdiff.c (do_unified): Preserve text after '@@' in
	unified input.
	* tests/preserve1/run-test: New test: that text after '@@' is
	preserved.
	* Makefile.am: Run test.

2002-05-16  Tim Waugh  <twaugh@redhat.com>

	* src/filterdiff.c (do_unified, do_context): Fix hunk numbering.
	* tests/lsdiff7/run-test, tests/lsdiff8/run-test,
	tests/lsdiff9/run-test: Test lsdiff -n and -nv output.
	* Makefile.am: Run tests.

2002-05-14  Tim Waugh  <twaugh@redhat.com>

	* doc/patchutils.xml: Remove selectdiff(1).
	* src/selectdiff.c: Removed.

	* Makefile.am: Don't build selectdiff.

	* src/filterdiff.c: Merge as-numbered-lines support in from
	selectdiff.
	* doc/patchutils.xml: Add --as-numbered-lines to filterdiff(1).
	* tests/select1/run-test, tests/select2/run-test,
	tests/select8/run-test, tests/select9/run-test: Test filterdiff
	instead of selectdiff.

	* src/filterdiff.c: Merge lines support in from selectdiff.
	* doc/patchutils.xml: Add --lines to filterdiff(1), and copy
	examples section from selectdiff(1).
	* tests/select3/run-test, tests/select4/run-test: Test filterdiff
	instead of selectdiff.

	* tests/lscontext2/run-test: New test.
	* Makefile.am: Run it.

	* src/filterdiff.c: Merge hunk support in from selectdiff.
	* doc/patchutils.xml: Add --hunks and -# to filterdiff(1).
	* tests/select5/run-test, tests/select6/run-test,
	tests/select7/run-test: Test filterdiff instead of selectdiff.

	* src/filterdiff.c (filterdiff): Don't read the first line of the
	hunk, but leave it to do_unified and do_context.
	(do_unified, do_context): Read the first line of the hunk.

2002-05-13  Tim Waugh  <twaugh@redhat.com>

	* doc/patchutils.xml: Document that rediff can now handle the
	removal of more than one hunk at a time.

	* src/selectdiff.c: Make the empty query do something useful.
	* doc/patchutils.xml: Document that.  Also document lsdiff -nv
	output.

	* tests/delhunk5/run-test: New test.
	* Makefile.am: Doesn't pass yet.

	* src/rediff.c (struct file_info): Two new fields: info_written to
	record whether the file banner has been output, and info_pending to
	record whether it needs to be output (i.e. whether it has been
	deferred due to action in removed_hunk).
	(copy_trailing): Better checking.
	(copy_to): Output file banner if it has been deferred and still not
	displayed.
	(removed_hunk): No longer need info_written parameter.  Set
	info->info_pending on hunks following those removed.
	(show_modified_hunk): Use info->info_written instead of a local
	variable.
	(rediff): Initialise info->info_written and info->info_pending.
	* tests/delhunk4/run-test: New test..
	* Makefile.am: ..which we now pass.

	* src/rediff.c (removed_hunk): Get passed a pointer to the hunk
	pointer, so that we can modify it.  Deal with multiple removed
	hunks (on their own).
	(show_modified_hunk): Get passed a pointer to the hunk pointer,
	so that we can modify it.  Pass it to removed_hunk, so that it can.
	(rediff): Pass a pointer to the hunk pointer to show_modified_hunk.
	* tests/delhunk3/run-test: New test..
	* Makefile.am: ..which we now pass.

2002-05-10  Tim Waugh  <twaugh@redhat.com>

	* patchutils.spec.in: The archive is now distributed in
	.tar.bz2 format.

2002-05-10  Tim Waugh  <twaugh@redhat.com>

	* tests/select9/run-test: New test.
	* Makefile.am: Run it.

	* tests/select8/run-test: New test.
	* Makefile.am: Run it.

	* tests/select7/run-test: New test.
	* Makefile.am: Run it.

	* tests/select6/run-test: New test.
	* Makefile.am: Run it.

	* tests/select5/run-test: New test.
	* Makefile.am: Run it.

	* tests/select4/run-test: New test.
	* Makefile.am: Run it.

	* tests/select3/run-test: New test.
	* Makefile.am: Run it.

	* tests/select2/run-test: New test.
	* Makefile.am: Run it.

	* tests/select1/run-test: New test.
	* Makefile.am: Run it.

	* tests/common.sh: Allow for selectdiff tests.

	* src/selectdiff.c: New file.
	* Makefile.am: Build it.
	* doc/patchutils.xml: Document it.

	* src/interdiff.c, src/filterdiff.c: Moved stripped() to..
	* src/diff.h, src/diff.c: ..here.

	* src/filterdiff.c (filterdiff): Fix a small memory leak.

2002-05-09  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 0.2.13 (stable).

2002-05-08  Tim Waugh  <twaugh@redhat.com>

	* tests/lsdiff6/run-test: New test, for --strip and --addprefix.
	* Makefile.am: Run test.

	* src/filterdiff.c (main): Preserve the old semantics of -p.

	* src/filterdiff.c (stripped): Keep /dev/null unchanged.  Don't
	treat './'-prefixed names specially.

	* src/filterdiff.c (main): Understand --addprefix.
	New global, prefix_to_add, for --addprefix.
	(syntax_str): Document --addprefix.
	(strip_header_line): Rename to output_header_line, and output
	prefix too.
	(display_filename): Implement --addprefix, and move --strip
	functionality here too.
	* doc/patchutils.xml: Document --addprefix.

	* src/filterdiff.c: New global, strip_components, for --strip.
	(main): Understand --strip.
	(syntax_str): Document --strip.
	(strip_header_line): Help implement --strip.
	(stripped, filterdiff, do_unified, do_context): Implement --strip.

	* doc/patchutils.xml: Document --strip.

	* src/filterdiff.c (filterdiff): Fix lsdiff -s.
	* tests/lsdiff2/run-test: More extensive testing of -s.

2002-05-01  Tim Waugh  <twaugh@redhat.com>

	* src/filterdiff.c: Verbose output mode, which lists line numbers of
	all hunks.
	* doc/patchutils.xml: Document it.

	* doc/patchutils.xml: Put <screen> elements inside <para>s.

2002-04-30  Tim Waugh  <twaugh@redhat.com>

	* src/interdiff.c: New option --no-revert-omitted.
	* doc/patchutils.xml: Document it.

2002-04-25  IIDA Yosiaki  <iidi@ring.gr.jp>

	* Makefile.am (AM_CFLAGS): Add -I$(srcdir)/src for getopt.h.
	* configure.in: Use AC_LIBOBJ instead of LIBOBJS.
	* src/interdiff.c: Include alloca.h if necessary.
	* Makefile.am (install-exec-hook): Use $(transform) so
	that --program-prefix=PREFIX works.
	* Makefile.am (uninstall-hook): Ditto.
	Use -f option so that uninstalling twice works.

2002-04-23  Tim Waugh  <twaugh@redhat.com>

	* src/filterdiff.c (file_exists): Handle new-style time stamp, as
	generated by diff from GNU diffutils 2.8.1.

	* patchutils.spec.in: Run tests after build step.

	* diff.c, diff.h, filterdiff.c, getopt.c, getopt.h, getopt1.c,
	interdiff.c, myerror.c, rediff.c, util.c, util.h: Moved...
	* src/: .. to here.
	* configure.in, Makefile.am, clean.sh, tests/common.sh: Adjustments.

	* doc/patchutils.xml: Moved...
	* patchutils.xml: .. from here.
	* Makefile.am: Adjust to new location of patchutils.xml.
	* autogen.sh: Use automake 1.6.
	* configure.in: Set automake options.

2002-04-22  Tim Waugh  <twaugh@redhat.com>

	* interdiff.c (output_delta): Evasive action needs different output
	when reverting (don't revert first patch).

	* splitdiff.in: Fix edge case.

2002-04-19  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 0.2.12 (stable).

2002-04-19  Tim Waugh  <twaugh@redhat.com>

	* tests/linux-2.4.13-ac6-7/run-test: Stricter checking.
	* interdiff.c (strip_context): When dumping made-up lines, fix up
	offset line to account for that line as well.

	* patchutils.xml (filterdiff.1): Thought of a new use for filterdiff.
	Put it in the man page.

2002-04-17  Tim Waugh  <twaugh@redhat.com>

	* interdiff.c: New option, --debug.

	* patchutils.xml (interdiff.1): Some examples.

	* interdiff.c: New option, -q.
	* patchutils.xml (interdiff.1, combinediff.1): Document it.

	* interdiff.c (trim_context): Also handle trimming made-up lines.
	(output_delta): Let trim_context deal with some cases that would
	otherwise require evasive action.  Fixes linux-2.4.13-ac6-7 test
	case.
	* Makefile.am: Expect linux-2.4.13-ac6-7 to pass now.

	* filterdiff.c (filterdiff): Fix filterp test case.  Now the -p
	option works in filter mode.
	* Makefile.am: Expect filterp to pass now.
	* patchutils.xml: Document -p for filterdiff.

	* tests/linux-2.4.3-ac6-7/run-test: New test.
	* tests/filterp/run-test: New test.
	* Makefile.am: Run tests.  Don't expect them to pass yet.

	* interdiff.c (output_delta): When taking evasive action, remember
	to remove the temporary files that we no longer need.

	* filterdiff.c (file_exists): Can't use mktime on times before the
	Epoch.  Just examine the tm fields instead.

	* interdiff.c (output_delta): The default number of lines of context
	is 3, not 2.

2002-04-16  Tim Waugh  <twaugh@redhat.com>

	* editdiff.in: Allow $EDITOR to contain parameters.

2002-04-04  Tim Waugh  <twaugh@redhat.com>

	* patchutils.xml (interdiff.1, combinediff.1, filterdiff.1):
	Describe shell wildcard pattern rules as used by patchutils.

2002-03-20  Tim Waugh  <twaugh@redhat.com>

	* Makefile.am: Run lsdiff5 test.
	* tests/lsdiff5/run-test: Test handling of differing context format
	styles.
	* filterdiff.c (do_context): Handle GNU diff's output format, which
	differs slightly from the one described in SuSV2.

2002-03-14  IIDA Yosiaki  <iida@ring.gr.jp>

	* Makefile.am: Use DESTDIR in install/uninstall hooks.

2002-03-14  Tim Waugh  <twaugh@redhat.com>

	* rediff.c: Tidy, remove compilation warnings.

2002-03-13  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 0.2.11 (stable).

2002-03-13  Tim Waugh  <twaugh@redhat.com>

	* rediff.c (removed_hunk): Minimally correct offset banners.

	* patchutils.xml (rediff.1): Add information about what types of
	edits are handled.
	(editdiff.1): Add as refname for rediff.
	* Makefile.am: Ship editdiff.1.

	* tests/edit10/run-test: New test.
	* Makefile.am: Run test.

	* Makefile.am: Now we pass delhunk1 and delhunk2.

	* rediff.c (added_hunk): Keep track of how many lines of diff
	output we are expecting.
	(removed_hunk): Implement.
	(show_modified_hunk): Skip lines from removed hunks if necessary.
	Only show an offset banner if we have something to say about it.
	(rediff): Further fixes to the code deciding which hunk is
	affected (account for header lines in the right hunk).

	* rediff.c (main): Complain if the edited file isn't there.
	We probably ought to check the exit status from diff as well.

	* tests/edit9/run-test: New test.
	* Makefile.am: Run it.

	* rediff.c (show_modified_hunk): Fix trimming algorithm.

	* tests/edit8/run-test: New test.
	* Makefile.am: Run it.

	* rediff.c (show_modified_hunk): Fix offset recalculation when
	added modifications are removed.
	(adjust_offsets_and_copy): Reset the offset when a new file is
	encountered.
	(copy_to): Propagate offset adjustments.
	(rediff): Likewise.

2002-03-09  Tim Waugh  <twaugh@redhat.com>

	* rediff.c (rediff, show_modified_hunk): Discard offsets when a
	hunk is added right at the end of the file.
	* Makefile.am: Now we pass addhunk1.

	* rediff.c (rediff): Account for header lines when deciding which
	hunk is affected.
	* Makefile.am: Now we pass addhunk3.

	* tests/nondiff1/run-test: New test.
	* Makefile.am: Run test.

	* patchutils.xml (filterdiff.1, lsdiff.1, grepdiff.1): Mention that
	context format diffs will work as well.

	* interdiff.c (index_patch2): Remove unneeded warning.
	
	* filterdiff.c (do_unified): New function, split out from filterdiff.
	(do_context): New function for handling context diff format.
	(filterdiff): Handle context diff format as well.
	* tests/lscontext1/run-test: New test.
	* Makefile.am: Run test.

2002-03-08  Tim Waugh  <twaugh@redhat.com>

	* interdiff.c (index_patch2, interdiff): Complain if we think that
	the input is in context diff format.
	* filterdiff.c (filterdiff): Likewise.

	* patchutils.xml (interdiff.1): Give a hint about how to use
	interdiff to reverse a patch.

	* splitdiff.in: Give a hint about how to use it if the input looks
	wrong.

	* filterdiff.c: Move sys/types.h inclusion earlier to work around
	an apparent FreeBSD C library bug.

2002-03-05  Tim Waugh  <twaugh@redhat.com>

	* interdiff.c (main): Fix getopt short-options string.
	(main, output_delta): Support -i, -b, and -B.
	* patchutils.xml: Update interdiff(1) and combinediff(1).

2002-03-01  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 0.2.10 (stable).

2002-03-01  Tim Waugh  <twaugh@redhat.com>

	* patchutils.xml: Put some examples in lsdiff(1).

	* TODO: Updated.
	* Makefile.am: Now we pass nondiff.
	* filterdiff.c (filterdiff): Show non-diff lines when excluding.
	* tests/common.sh: Support filterdiff testing.
	* tests/nondiff/run-test: New test.

	* patchutils.xml: Update interdiff(1).

	* Makefile.am (XFAIL_TESTS): Now we pass fuzz1.

	* interdiff.c (trim_context): New function for trimming context
	to prevent spurious fuzz.
	(output_delta): Use it.

	* rediff.c (read_atatline): Move..
	* diff.c (read_atatline): ..to here.
	* diff.h: Prototype for read_atatline.

2002-02-28  Tim Waugh  <twaugh@redhat.com>

	* interdiff.c (construct_unline): New function.
	(write_file): Generate a unique line so that problems can be
	identified when diffing.
	(output_delta): Identify problems when diffing.
	* tests/linux-2.2.17-pre4-5/run-test: Patch -R is never going to
	work with this test, since a proper interdiff is impossible.
	* Makefile.am: We pass the important bit of linux-2.2.17-pre4-5
	finally.

2002-02-24  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 0.2.9 (stable).

2002-02-06  Tim Waugh  <twaugh@redhat.com>

	* diff.c (best_name): Don't consider /dev/null as a good name for
	a modified file.

2002-01-31  Tim Waugh  <twaugh@redhat.com>

	* patchutils.xml: Put an example in for grepdiff.

2002-01-31  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 0.2.8 (stable).

2002-01-31  Tim Waugh  <twaugh@redhat.com>

	* filterdiff.c (determine_mode_from_name): Name change from
	'list_or_filter'.
	(set_grep): New function.
	(mode): New global enum, replacing 'listing'.
	(main): Handle --grep.
	(syntax_str): Document --grep.
	(filterdiff): Check mode instead of listing.  Handle grep mode.
	* Makefile.am: Add grepdiff alias for filterdiff.
	* patchutils.xml: Add refentry for grepdiff.
	* tests/common.sh: Set GREPDIFF.
	* Makefile.am, tests/grepdiff1/run-test: New test.

2002-01-22  Tim Waugh  <twaugh@redhat.com>

	* filterdiff.c (filterdiff): Handle filenames with spaces.
	* interdiff.c (index_patch2, interdiff): Likewise.
	* tests/lsdiff4/run-test, Makefile.am: New test for lsdiff.

2002-01-08  Tim Waugh  <twaugh@redhat.com>

	* patchutils.xml: Fix typo.

2001-12-18  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 0.2.7 (stable).

2001-12-18  Moritz Barsnick  <barsnick@gmx.net>

	* tests/*/run-test: Use backticks instead of $(...) for portability.
	(Not all listed since there are _so_ many..)
	* Makefile.am: Use [ -f ... ] instead of [ -e ... ] for portability.

2001-12-18  Tim Waugh  <twaugh@redhat.com>

	* patchutils.xml: Fix filterdiff example in man page.

2001-12-18  Moritz Barsnick  <barsnick@gmx.net>

	* fixcvsdiff.in, splitdiff.in: Get perl location from autoconf.

2001-12-18  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Check for perl, generate fixcvsdiff from
	fixcvsdiff.in.
	* fixcvsdiff: Moved...
	* fixcvsdiff.in: ...here.

	* Makefile.am: Only ship the test scripts in the tests directory,
	not all the CVS junk as well.

	* Makefile.am: Don't ship the generated scripts.

2001-12-18  Moritz Barsnick  <barsnick@gmx.net>

	* configure.in, Makefile.am, getopt.c, getopt.h, getopt1.c: Supply
	getopt_long if it's not available from the system.

	* myerror.c: Include sys/types.h if it's present, for pid_t.

2001-12-17  Tim Waugh  <twaugh@redhat.com>

	* tests/lsdiff3/run-test, Makefile.am: Test that -s works across
	locales.
	* filterdiff.c (file_exists): Use strptime to interpret the
	timestamp.
	(main): Set LC_TIME to C since that's what diff outputs time in.

	* editdiff.in: Fix argument parsing.

2001-12-12  Tim Waugh  <twaugh@redhat.com>

	* filterdiff.c (file_exists): Handle patches that were made in
	a different time zone to the local machine.

2001-12-10  Tim Waugh  <twaugh@redhat.com>

	* filterdiff.c (show_status): New global.
	(file_exists): New function.
	(filterdiff): Show file additions, modifications and removals.
	(syntax_str): New option -s.
	(main): Make status display optional.
	* tests/lsdiff2/run-test: Test status functionality.
	* Makefile.am: Run the test.
	* patchutils.xml: Updated to reflect new option.

	* Makefile.am: Now lsdiff is just a symlink to filterdiff.
	* configure.in: Don't create lsdiff from lsdiff.in any more.
	* patchutils.xml: Update, remove duplicate filterdiff section.
	* lsdiff.in: Removed.  No longer needed.

	* filterdiff.c (listing, numbering): New globals.
	(stripped): New function.
	(filterdiff): Implement lsdiff too.
	(syntax_str): Updated.
	(set_list): Run as lsdiff.
	(set_filter): Run as filterdiff.
	(list_or_filter): Determine execution mode from filename.
	(main): But command line parameter can override it.

2001-12-07  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 0.2.6 (stable).

2001-12-07  Tim Waugh  <twaugh@redhat.com>

	* patchutils.xml: New file from which all the man pages are now
	generated.
	* Makefile.am: Generate the man pages.

2001-12-06  Tim Waugh  <twaugh@redhat.com>

	* interdiff.c (output_delta): Preserve time stamps.
	* tests/nodate/run-test: Fix test to cope with that.

	* lsdiff.in: Fix name selection to match that used in diff.c and
	in patch(1).  Better handling of incorrect input.

	* tests/U0/run-test: New test case.
	* Makefile.am: Now we pass it.

	* interdiff.c (munge_diff_output): Remove (no longer needed).
	* interdiff.c (output_delta): Never call munge_diff_output.
	
	* diff.c (best_name): Take the length of the entire pathname into
	account as well.

2001-12-05  Tim Waugh  <twaugh@redhat.com>

	* tests/addhunk3/run-test: New test case.
	* Makefile.am: We don't pass it.

2001-12-04  Tim Waugh  <twaugh@redhat.com>

	* editdiff.in, configure.in, Makefile.am, rediff.1: New file
	editdiff.in.  This is a short wrapper script for rediff to make
	it more convenient to use.

2001-12-03  Tim Waugh  <twaugh@redhat.com>

	* util.c, util.h: getline should return ssize_t.

	* filterdiff.c (filterdiff): getline takes a size_t parameter.
	* interdiff.c (create_orig, output_patch1_only, apply_patch,
	munge_diff_output, copy_residue, index_patch2, interdiff): Likewise.
	* rediff.c (copy_hunk, adjust_offsets_and_copy, copy_lines,
	added_hunk, show_modified_hunk, rediff): Likewise.

2001-12-03  Adrian Bunk  <bunk@fs.tum.de>

	* lsdiff.1: Program name is lsdiff not rediff.

2001-12-02  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 0.2.5 (stable).

2001-11-29  Tim Waugh  <twaugh@redhat.com>

	* tests/fuzz1/run-test, Makefile.am: New test, which we don't pass.
	Mostly harmless.

2001-11-28  Tim Waugh  <twaugh@redhat.com>

	* interdiff.c (output_patch1_only): Since we might invert the
	meaning of '-' and '+', make sure to swap the line counts
	accordingly.
	* tests/combine2/run-test, tests/combine3/run-test: New tests.
	* Makefile.am: Now we pass those tests.

2001-11-27  Tim Waugh  <twaugh@redhat.com>

	* lsdiff.in: Fix name selection.
	* tests/common.sh: Support for lsdiff tests.
	* tests/lsdiff1/run-test, Makefile.am: New test, which we now pass.

2001-11-27  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 0.2.4 (stable).

2001-11-27  Tim Waugh  <twaugh@redhat.com>

	* interdiff.c: Apply patch from Matthias Hanisch.
	(index_patch2): Use newline as a delimiter too.
	(interdiff): Likewise.
	* tests/nodate/run-test, Makefile.am: New test, which we now pass.

	* interdiff.c: New global 'combining', zero if running as interdiff.
	(create_orig): Handle reversed patches.
	(output_patch1_only): Likewise.
	(apply_patch): Likewise.
	(output_delta): Run-time combinediff differences.
	(interdiff): Likewise.
	(set_interdiff, set_combinediff): Set up running image for
	interpolating or combining.
	(interdiff_or_combinediff): Determine which from argv[0].
	(syntax, interdiff): But that's trumped by new options --interpolate
	and --combine.
	This (much more elegant) way of doing combinediff is due to
	Matthias Hanisch, who had the idea to reconstruct version 2 of
	the patched file rather than version 1.
	* interdiff.c (new_offset, apply_offsets): Remove (no longer needed).
	* interdiff.1, combinediff.1: Update with new options.

	* Makefile.am: No need to build combinediff separately now, but
	symbolic link trickery is needed instead.

	* patchutils.spec.in: New file.
	* configure.in: Create patchutils.spec.
	* Makefile.am: Distribute it.

	* AUTHORS, INSTALL, README, NEWS: New files.
	* Makefile.am: Don't need 'foreign' now.

2001-11-22  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 0.2.3 (stable).

2001-11-22  Tim Waugh  <twaugh@redhat.com>

	* rediff.c (copy_hunk): Return the number of lines copied.
	(adjust_offsets_and_copy): Likewise.
	(copy_lines): New function.
	(copy_trailing): New function to copy trailing non-diff lines.
	(copy_to): Extra parameter is_first, zero unless this is the first
	hunk.  Copy leading and trailing non-diff lines.
	(show_modified_hunk): Use copy_trailing.
	(rediff): Give copy_to its extra parameter.
	* Makefile.am: Now we pass the edit7 test.

	* rediff.c: Comments, clean-ups.

	* tests/addhunk1/run-test, tests/addhunk2/run-test: New tests.
	* Makefile.am: We don't pass those yet.

	* rediff.c (added_hunk): New function.  Make an attempt to deal
	with added hunks.
	(removed_hunk): Place-holder for removed hunk support.
	(show_modified_hunk): Some support for hunk additions/removals.
	(rediff): Preliminary support for hunk additions.

	* tests/delhunk1/run-test, tests/delhunk2/run-test: New tests.
	* Makefile.am: We don't pass those yet.

	* tests/trimcontext1/run-test: New test.
	* Makefile.am: We pass this, and now we also pass addhunk2.

2001-11-21  Tim Waugh  <twaugh@redhat.com>

	* tests/edit7/run-test: New test case.
	* Makefile.am: We fail it at the moment.

2001-11-20  Tim Waugh  <twaugh@redhat.com>

	* lsdiff.in, lsdiff.1: New files.
	* Makefile.am: lsdiff.
	* configure.in: Create lsdiff from lsdiff.in.

	* splitdiff.in, splitdiff.1: New files.
	* Makefile.am: splitdiff.
	* configure.in: Create splitdiff from splitdiff.in.

2001-11-20  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 0.2.2 (stable).

2001-11-20  Tim Waugh  <twaugh@redhat.com>

	* Makefile.am, tests/*/run-test, tests/common.sh: Integrate tests
	into make check.
	* tests/Makefile: No longer needed.

	* combinediff.1: New file.

	* tests/combine1/run-test: New test case.

2001-11-19  Tim Waugh  <twaugh@redhat.com>

	* interdiff.c: A few changes for combinediff.
	* Makefile.am: Build combinediff.
	* clean.sh: Automake 1.5 stuff.

	* rediff.c (rediff): Use xstrdup.

	* tests/Makefile: Some rediff test cases.
	* tests/edit1/run-test: New test case.
	* tests/edit2/run-test: New test case.
	* tests/edit3/run-test: New test case.
	* tests/edit4/run-test: New test case.
	* tests/edit5/run-test: New test case.
	* tests/edit6/run-test: New test case.

2001-11-18  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 0.2.1 (stable).

2001-11-17  Tim Waugh  <twaugh@redhat.com>

	* filterdiff.1: Change title from EXTRACTDIFF to FILTERDIFF.

	* rediff.c: New file.
	* rediff.1: New file.
	* Makefile.am: Build rediff.
	* tests/Makefile: Support for testing rediff.

2001-11-16  Matthias Hanisch  <matze@camline.com>

	* interdiff.c: New structure lines_info, for storing a tail
	pointer.
	(add_line): Use it.
	(create_orig): Likewise.
	(output_delta): Likewise.

	* interdiff.c (insert_line_before): New function.
	(add_line): Use it.

	* interdiff.c (add_line): Make appending to the list a fast
	operation with constant complexity.

	* interdiff.c (merge_lines): New function.
	(output_delta): Use it.

	* interdiff.c: These changes together give a substantial speed
	increase.

2001-11-13  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 0.2.0 (stable).

2001-11-13  Tim Waugh  <twaugh@redhat.com>

	* interdiff.1: Document -w.

2001-11-13  Matthias Hanisch  <matze@camline.com>

	* interdiff.c (ignore_whitespace): New global variable.
	(output_delta): Use it.
	(syntax, main): New option '-w' for ignoring white space.

2001-10-22  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 0.1.5 (devel).

2001-10-22  Tim Waugh  <twaugh@redhat.com>

	* Makefile.am: We need to distribute bin_SCRIPTS too.

2001-10-18  John Levon  <moz@compsoc.man.ac.uk>

	* fixcvsdiff: Tiny perl script for fixing cvs diff results.
	* fixcvsdiff.1: Manual page for script.
	* Makefile.am: Add fixcvsdiff.

2001-10-18  Tim Waugh  <twaugh@redhat.com>

	* interdiff.c (check_filename): Make static.
	* filterdiff.c (pat_include, pat_exclude, ignore_components,
	unzip, filterdiff, syntax): Make static.

2001-10-18  Stanislav Ievlev  <inger@altlinux.ru>

	* util.h: Check for older GCCs.

2001-10-17  Tim Waugh  <twaugh@redhat.com

	* configure.in: Version 0.1.4 (devel).

2001-10-17  Stanislav Ievlev  <inger@altlinux.ru>

	* diff.c (best_name): Use xmalloc.
	* interdiff.c (output_delta): Use TMPDIR or P_tmpdir for temporary
	directory path.
	* configure.in: Check for alloca (used in output_delta now).
	* Makefile.am: New file myerror.c.
	* myerror.c: New file.
	* util.h: Declare error() replacement function.
	* interdiff.c, util.c: Use new error function.

	* util.c (xmkstemp): New function.
	* util.h: Declare it.
	* interdiff.c (output_delta): Use it.

2001-10-17  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Test for error.h, error.
	* interdiff.c: Include error.h, errno.h.
	* util.h (FORMAT): Define appropriately.

2001-10-17  Stanislav Ievlev  <inger@altlinux.ru>

	* filterdiff.c, interdiff.c: Use NORETURN for syntax() functions.

2001-10-17  Tim Waugh  <twaugh@redhat.com>

	* util.h (NORETURN): Define appropriately depending on compiler.

2001-10-17  Marko Kreen  <marko@l-t.ee>

	* diff.c, filterdiff.c, interdiff.c, util.c, util.h: Make sure to
	include config.h where necessary, and don't include system headers
	from project headers.

2001-10-15  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 0.1.3 (devel).

2001-10-15  Marko Kreen  <marko@l-t.ee>

	* util.h: Declare xopen_unzip.

	* util.c (xopen_unzip): New function.

	* interdiff.c (unzip): New global variable.
	(syntax): Add -z option for decompression.
	(main): Handle -z option.

	* interdiff.1: Add -z option for decompression.

	* filterdiff.c (unzip): New global variable.
	(syntax_str): Add -z option for decompression.
	(main): Handle -z option.

	* filterdiff.1: Add -z option for decompression.

2001-09-21  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 0.1.2 (devel).

2001-09-21  Tim Waugh  <twaugh@redhat.com>

	* util.h: Apply patch from Christopher C. Chimelis
	<chris@debian.org> to fix build problems on alpha.

2001-05-29  Marko Kreen  <marko@l-t.ee>

	* configure.in: Check for <sys/types.h>.

2001-05-29  Moritz Barsnick  <barsnick@gmx.net>

	* filterdiff.c: Include <sys/types.h> for ssize_t.

	* util.h: Match util.c's xpipe declaration.  Include <sys/types.h>
	for pid_t.

2001-05-22  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 0.1.1 (devel).

2001-05-22  Tim Waugh  <twaugh@redhat.com>

	* TODO, BUGS, filterdiff.1: Updated.

2001-04-28  Marko Kreen  <marko@l-t.ee>

	* merge interdiff and extractdiff
	* new function getline() for non-glibc systems.
	* move xopen to util.c, new function xopen_seekable for
	  interdiff
	* use xmalloc in add_to_list, add_line
	* use xpipe in apply_patch, output_delta
	* calculate_num_lines, orig_num_lines, new_num_lines,
	  num_pathname_components, best_name -> diff.c
	* extractdiff -> filterdiff
	* set progname on startup - used in --help; should be
	  used in error messages too
	* hardwire program name in --version -> useful
	  when renamed.

2001-04-22  Tim Waugh  <twaugh@redhat.com>

	* interdiff.c (VERSION): Version 0.1.0 (devel).

2001-04-22  Tim Waugh  <twaugh@redhat.com>

	* interdiff.c (max_context, max_context_real,
	ignore_components, pat_drop_context): New globals.
	(human_readable): Default to on.
	(check_filename): New function.
	(output_delta): Generate specified amount of context.
	(copy_residue): Check file name for context settings.
	(interdiff): Likewise.
	(xopen): Return immediately if opening the file failed.
	(main): Getoptify.

	* util.c: New file.
	(xstrdup): Implement in terms of xmalloc and strcpy.
	(patlist_add, patlist_match, patlist_free): New.
	* util.h: New file.  Declare above functions.
	(xmalloc, xstrndup): Move...
	* interdiff.c: ...from here.

2001-02-23  Tim Waugh  <twaugh@redhat.com>

	* interdiff.c (calculate_num_lines): More careful string
	handling.

2001-02-23  Tim Waugh  <twaugh@redhat.com>

	* interdiff.c (VERSION): Version 0.0.10 (stable).

2001-02-23  Tim Waugh  <twaugh@redhat.com>

	* tests/comma/run-test: New test.
	* Makefile: Run test.
	* interdiff.c (calculate_num_lines): Calculate the number of
	lines in the original for "@@ -1 +x,y @@" correctly as 1, not y.
	Fixes comma test.

2000-11-05  Tim Waugh  <twaugh@redhat.com>

	* interdiff.c (xopen): Handle non-existent files.

2000-11-04  Tim Waugh  <twaugh@redhat.com>

	* interdiff.c (VERSION): Version 0.0.9 (stable).

2000-11-04  Tim Waugh  <twaugh@redhat.com>

	* interdiff.c (xopen): New function.  Get a seekable FILE stream
	from a possible non-seekable FILE stream.
	(main): Use it, because we need to seek.

2000-08-16  Tim Waugh  <twaugh@redhat.com>

	* interdiff.c (best_name): Shut gcc up (best is always
	initialised).

	* Makefile (DEBIAN_DEBUGFLAGS): Debian policy changes (Adrian
	Bunk).

2000-08-07  Tim Waugh  <twaugh@redhat.com>

	* interdiff.c (VERSION): Version 0.0.8 (stable).

2000-08-03  Tim Waugh  <twaugh@redhat.com>

	* interdiff.c (stripped): Ignore "./" at the beginning of names,
	for the purpose of comparison.

2000-08-03  Boszormenyi Zoltan  <zboszor@externet.hu>

	* interdiff.c (main): Several fixes in parameter parsing.

2000-08-02  Tim Waugh  <twaugh@redhat.com>

	* Makefile: Fix command substitution.

2000-08-02  Tim Waugh  <twaugh@redhat.com>

	* interdiff.c (VERSION): Version 0.0.7 (stable).

2000-08-02  Tim Waugh  <twaugh@redhat.com>

	* interdiff.c (file_in_list): Ignore pathname components when told
	to.

2000-08-01  Tim Waugh  <twaugh@redhat.com>

	* interdiff.c (create_orig): Take note of @@ lines properly.
	(stripped): New function.

	* interdiff.1: Updated for -p.

	* interdiff.c (create_orig): Don't keep freeing memory that will
	be immediately reallocated.
	(interdiff): Likewise.
	(output_reverted): Likewise.
	(switch_order_preference): New function.
	(main): Tidy up option parsing (but we'll use getopt someday).
	(syntax): Update syntax.

	* tests/newline3/run-test: New test.

	* tests/copy1/run-test: New test.

	* tests/newline2/run-test: New test.

	* tests/apply1/run-test: New test.

	* tests/revert2/run-test: New test.

	* Makefile (TESTS): Add revert2, apply1, copy1, newline2 and
	newline3 to regression tests.

	* interdiff.c (output_reverted): Handle patches for files with no
	newline in the last line.  Now newline3 passes.

	* interdiff.c (copy_residue): Fix @@ handling.  Now copy1 passes.

	* interdiff.c (apply_patch): Fix @@ handling.  Now apply1 passes.

	* interdiff.c (output_reverted): Take note of @@ lines (properly).
	(calculate_num_lines): New function to calculate the number of
	context lines expected from either the original file or the
	modified file.
	(orig_num_lines): New function.
	(new_num_lines): New function.
	(interdiff): Use xstrdup not strdup.


2000-08-01  Tim Waugh  <twaugh@redhat.com>

	* interdiff.c (VERSION): Version 0.0.6 (stable).

2000-08-01  Tim Waugh  <twaugh@redhat.com>

	* Makefile (TESTS): Add dashes4 to regression tests.

	* tests/dashes4/run-test: New test.

2000-07-31  Tim Waugh  <twaugh@redhat.com>

	* tests/dashes2/run-test: Some fixes.

	* tests/dashes1/run-test: Some fixes.

	* Makefile (TESTS): Add dashes, dashes1, dashes2 and dashes3 to
	regression tests.

	* tests/dashes3/run-test: New test.

	* interdiff.c (interdiff): Don't fclose anything in this function
	since it is done in main.
	(index_patch2): Take note of @@ lines.
	(apply_patch): Likewise.
	(copy_residue): Don't free line every time round the loop.
	(copy_residue): Take note of @@ lines.

	* Makefile (TESTS): Add revert1 and gendiff2 to regression tests.

	* tests/revert1/run-test: New test.

	* tests/gendiff2/run-test: New test.

	* interdiff.c (index_patch2): Use best_name.
	(output_reverted): How did this ever work?!  Be paranoid about @@
	lines, and skip over the space in between the line numbers.

2000-07-31  Tim Waugh  <twaugh@redhat.com>

	* interdiff.c (VERSION): Version 0.0.5 (stable).

2000-07-31  Tim Waugh  <twaugh@redhat.com>

	* interdiff.c (output_delta): Use -U0 instead of the (deprecated)
	-0 option.

2000-07-31  Jason Bucata  <jbucata@earthlink.net>

	* interdiff.c (xstrdup): New function.
	(add_to_list): Use it.
	(add_line): Likewise.
	(output_reverted): Likewise.
	(interdiff): Likewise.
	(xstrndup): New function.
	(output_reverted): Use it.
	(interdiff): Likewise.


2000-07-31  Tim Waugh  <twaugh@redhat.com>

	* Makefile (TESTS): Add gendiff1 to regression tests.

	* interdiff.c (output_reverted): Read the oldname line from p1
	rather than by parameter.
	(num_pathname_components): New function.
	(best_name): New function.
	(interdiff): Work out the best name to use.  Doesn't use Index:
	lines yet.

	* tests/gendiff1/run-test: New test.

2000-07-26  Tim Waugh  <twaugh@redhat.com>

	* interdiff.c (VERSION): Version 0.0.4 (stable).

2000-07-26  Tim Waugh  <twaugh@redhat.com>

	* interdiff.1: Updated date.

	* interdiff.spec: Created.

2000-07-25  Tim Waugh  <twaugh@redhat.com>

	* tests/linux-2.2.17-pre4-5/run-test: New test case.  Needs to be
	distilled.

	* interdiff.c (output_reverted): Only display patch separator if
	-h is specified.
	(output_delta): Likewise.
	(copy_residue): Likewise.

2000-07-24  Tim Waugh  <twaugh@redhat.com>

	(munge_diff_output): Avoid compile warning.
	(create_orig): Deal with broken patches (fixes
	tests/broken1.tar).

2000-07-24  Tim Waugh  <twaugh@redhat.com>

	* interdiff.c (VERSION): Version 0.0.3 (stable).

	* Makefile (sure): Regression tests.

	* interdiff.c (munge_diff_output): New function.
	(output_delta): Find out if either patch removes the file.  If
	not, call munge_diff_output to fix up the diff output.

2000-07-21  Tim Waugh  <twaugh@redhat.com>

	* interdiff.c (output_delta): Use mkstemp to create temporary
	files.
	(apply_patch): Use PATCH.
	(output_delta): Use DIFF.
	(output_delta): Likewise.
	(DIFF): Define if not already defined.
	(PATCH): Likewise.
	(VERSION): Version 0.0.2 (stable).

2000-07-19  Tim Waugh  <twaugh@redhat.com>

	* interdiff.c (output_delta): Remove redundant comment.

	(interdiff): Prevent false alarms.

2000-07-19  Tim Waugh  <twaugh@redhat.com>

	* interdiff.c (copy_residue): Put patch delimiter in.
	(output_delta): Patch delimiter reflects options actually given to
	diff.
	(main): -h option turns on human-readability.
	(VERSION): Version 0.0.1 (stable).

